%define		PYVER		2.6
%define		__python	python%{PYVER}
%define		PVER		%(echo %{PYVER} | awk -F. '{print$1$2}')
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs for X.
Name:		gtk2+
Version:	2.22.0
Release:	1
BuildArch:	i686
Provides:	gtk2
License:	GNU/GPL
URL:		ftp://ftp.gtk.org/pub/gtk/
Group:		System/Libraries
BuildRoot: 	%{_tmppath}/%{name}-buildroot

Source: 	gtk+-%{version}.tar.bz2

# Patches
# workaround incorrext gtk_init by adobe flash, so it works
# in browsers like konqueror again
# found at http://developer.momonga-linux.org/viewvc/trunk/pkgs/gtk2/091_workaround_no_gtk_init_incorrect_display.patch?view=markup&pathrev=18519
#Patch11:	091_workaround_no_gtk_init_incorrect_display.patch

BuildRequires(pre): 	libtasn1-devel >= 2.4 libtasn1 >= 2.4

# Versions (keep actually!)
%define atk_version 1.29.2-1
%define cairo_version 1.8.6-1
%define pango_version 1.26.1-1
%define glib_version 2.23.2-1
%define bin_version 2.10.0

#
%define _unpackaged_files_terminate_build      1
%define _missing_doc_files_terminate_build     1

# Requires:
# CCux Bug #25 - gtk-query-immodules-2.0 links against it
Requires:	libXrandr
Requires:	libXcursor
Requires:	libXcomposite
Requires:	libXdamage
Requires:	libXfixes
Requires:	libXau
Requires:	libxcb
Requires:	libXdmcp
# required for icon themes apis to work
Requires: 	hicolor-icon-theme

# PRErequires
# We need to prereq these so we can run gtk-query-immodules-2.0
Requires(pre): 	glib >= %{glib_version}
Requires(pre): 	atk >= %{atk_version}
Requires(pre): 	pango >= %{pango_version}
# and these for gdk-pixbuf-query-loaders
Requires(pre): 	libtiff >= 3.6.1

# Obsoletes
Obsoletes:	gtk2+-doc
# gail got integrated into gtk+ 2.14
Obsoletes:	gail

# Provides
Provides:	gail = %{version}

# Buildrequires:
# Manual build dependencies
BuildRequires: automake
BuildRequires: autoconf
BuildRequires: libtool
BuildRequires: pkg-config
BuildRequires: gettext
BuildRequires: gtk-doc
BuildRequires: cairo-devel >= %{cairo_version}
BuildRequires: libxcb-devel
BuildRequires: xcb-util-devel
#BuildRequires: gamin-devel
BuildRequires: gdk-pixbuf-devel

BuildRequires: gobject-introspection-devel
BuildRequires: libffi-devel

BuildRequires:  libXxf86vm-devel
BuildRequires:  libXdamage-devel

#Automatically resolved build dependencies
BuildRequires: atk-devel >= %{atk_version}
BuildRequires: coreutils
BuildRequires: cups-devel
BuildRequires: e2fsprogs-devel
BuildRequires: expat-devel
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
#BuildRequires: gail-devel
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: gnutls-devel
BuildRequires: jasper-devel
BuildRequires: krb5-devel
BuildRequires: libgcrypt-devel
BuildRequires: libgpg-error-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libtasn1-devel
BuildRequires: libtiff-devel
BuildRequires: libX11-devel
BuildRequires: libXcomposite-devel
BuildRequires: libXcursor-devel
BuildRequires: libXdamage-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXi-devel
BuildRequires: libXinerama-devel
BuildRequires: libXrandr-devel
BuildRequires: libXrender-devel
BuildRequires: pango-devel
BuildRequires: pixman-devel
BuildRequires: zlib-devel

%description
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

%package	devel
Summary:	Development tools for GTK+ applications
Group:		Development/Libraries
Requires:	gtk2+ = %{version}-%{release}
Requires:	pango-devel >= %{pango_version}
Requires:	atk-devel >= %{atk_version}
Requires:	glib-devel >= %{glib_version}
Requires:	cairo-devel >= %{cairo_version}
Requires:	libX11-devel, libXcursor-devel, libXinerama-devel
Requires:	libXext-devel, libXi-devel, libXrandr-devel
Requires:	libXfixes-devel
Requires:	libxcb-devel
Requires:	pkg-config
## avoid header collisions
Conflicts:	gtk+-devel <= 1.2.8
Conflicts:	gdk-pixbuf-devel <= 0.11
# gail got integrated into gtk+ 2.14
Obsoletes:	gail-devel
Provides:	gail-devel = %{version}

%description	devel
The gtk+-devel package contains the header files and developer
docs for the GTK+ widget toolkit.

%post
ldconfig
gtk-query-immodules-2.0 > /etc/gtk-2.0/gtk.immodules

%postun
ldconfig

%prep
%setup -q -n gtk+-%{version}

FIX=$(find -type f -name "*" -exec grep -I -l -e "^#!/usr/bin/python" -e "^#!/usr/bin/env python" -e "^#! /usr/bin/python" -e "^#! /usr/bin/env python" "{}" \; )
for i in $FIX; do
    sed -i "s,^#!/usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#! /usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#!/usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i
    sed -i "s,^#! /usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i    
done


#%patch11 -p1

for i in config.guess config.sub ; do
	test -f %{_datadir}/libtool/$i && cp %{_datadir}/libtool/$i .
done

%build

if ! pkg-config --exists pangoxft ; then
        echo "No pangoxft.pc!"
        exit 1
fi

%configure --with-xinput=xfree --disable-gtk-doc --disable-rebuilds --with-included-loaders=png PYTHON=/usr/bin/python%{PYVER}

## smp_mflags doesn't work for now due to gdk-pixbuf.loaders, may be fixed 
## past gtk 2.1.2
make CFLAGS="-ggdb -O0"
# turn off for now, since floatingtest needs a display
#make check

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT        \
             RUN_QUERY_IMMODULES_TEST=false \
             RUN_QUERY_LOADER_TEST=false 

%find_lang gtk20
%find_lang gtk20-properties

cat gtk20.lang gtk20-properties.lang > all.lang

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0
#
# Make cleaned-up versions of tutorials, examples, and faq for installation
#
mkdir -p tmpdocs
cp -aR docs/tutorial/html tmpdocs/tutorial
cp -aR docs/faq/html tmpdocs/faq

for dir in examples/* ; do
  if [ -d $dir ] ; then
     mkdir -p tmpdocs/$dir
     for file in $dir/* ; do
       install -m 0644 $file tmpdocs/$dir
     done
  fi
done


touch $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/gtk.immodules
touch $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/gdk-pixbuf.loaders

#
# We need the substitution of $host so we use an external
# file list
#
echo %dir %_sysconfdir/gtk-2.0 >> all.lang
echo %ghost %_sysconfdir/gtk-2.0/gtk.immodules >> all.lang
echo %ghost %_sysconfdir/gtk-2.0/gdk-pixbuf.loaders >> all.lang
echo %ghost %_sysconfdir/gtk-2.0/im-multipress.conf >> all.lang

%files -f all.lang
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS README
%_bindir/gtk-demo
%_bindir/gtk-builder-convert
%_bindir/gtk-query-immodules-2.0*
%_bindir/gtk-update-icon-cache
%_libdir/libgailutil.so.*
%_libdir/libgtk-x11-2.0.so.*
%_libdir/libgdk-x11-2.0.so.*
%dir %_libdir/gtk-2.0
%_libdir/gtk-2.0/%{bin_version}
%_libdir/gtk-2.0/modules/*.so
%_datadir/gtk-2.0
%_datadir/themes/Default
%_datadir/themes/Emacs
%_datadir/themes/Raleigh

%files devel
%defattr(-, root, root)
#%_libdir/*.la
%_libdir/gtk-2.0/%{bin_version}/*/*.la
%_libdir/lib*.so
%dir %_libdir/gtk-2.0
%_libdir/gtk-2.0/include
%_libdir/gtk-2.0/modules/*.la
%_libdir/libgailutil.la
%_libdir/libgdk-x11-2.0.la
%_libdir/libgtk-x11-2.0.la
%_datadir/gtk-doc/
%_mandir/man1
%_includedir
%_aclocal
%_pkgconfig
%doc tmpdocs/tutorial
%doc tmpdocs/faq
%doc tmpdocs/examples
%{_libdir}/girepository-1.0/Gdk-2.0.typelib
%{_libdir}/girepository-1.0/Gtk-2.0.typelib
%{_libdir}/girepository-1.0/GdkX11-2.0.typelib
%{_datadir}/gir-1.0/Gdk-2.0.gir
%{_datadir}/gir-1.0/Gtk-2.0.gir
%{_datadir}/gir-1.0/GdkX11-2.0.gir

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Sep 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.22.0-1
- Version update
* Sun Aug 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.21.6-1
- Version update
* Thu Aug 12 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.21.5-1
- Version update
* Thu Aug 12 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.20.0-2
- rebuilt to fix pkgconfig gtk2+ dependency provides
* Sat Mar 27 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.20.0-1
- Version update
* Fri Feb 05 2010 Christian Metzen <metzench@ccux-linux.de> 2.19.4-1
- Version update
* Tue Dec 01 2009 Christian Metzen <metzench@ccux-linux.de> 2.18.4-1
- Version update
* Tue Nov 24 2009 Christian Metzen <metzench@ccux-linux.de> 2.18.3-2
- python 2.6 fix
* Sat Nov 21 2009 Christian Metzen <metzench@ccux-linux.de> 2.18.3-1
- Version update
* Sun Jul 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.16.5-1
- Version update
* Mon Mar 23 2009 Christian Wasem <wasem@ccux-linux.de> 2.16.0-1
- Version update
* Fri Jan 09 2009 Christian Wasem <wasem@ccux-linux.de> 2.15.0-1
- Version update
* Sat Oct 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.14.3-1
- Version update
- revised BuildRequires (FS#44)
* Sun Jul 20 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.11-4
- more requirement additions
* Sun Jul 20 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.11-3
- added libXcursor as requirement
* Thu Jul 17 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.11-2
- fixes bug #25
* Wed Jul 02 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.11-1
- Version update
* Thu May 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.12.9-1
- Version update
* Wed Mar 12 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.8-1
- Version update
* Sat Jan 05 2008 Christian Metzen <metzench@ccux-linux.de> 2.12.3-1
- Version update
* Tue Nov 27 2007 Christian Metzen <metzench@ccux-linux.de> 2.12.2-1
- Version update
* Sun Oct 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.12.1-2
- added workaround against incorrect gtk_init_display
* Thu Oct 18 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.12.1-1
- Version update
* Fri Sep 28 2007 Christian Metzen <metzench@ccux-linux.de> 2.12.0-1
- Version update
* Sun Jul 29 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.10.14-1
- Version update
* Fri Mar 16 2007 Christian Metzen <metzench@ccux-linux.de> 2.10.11-1
- Version update
* Wed Nov 08 2006 Christian Metzen <metzench@ccux-linux.de> 2.10.6-2
- clean buildchain
* Thu Oct 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.10.6-1
- Version update
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 2.10.4-1
- Version update
* Wed Aug 23 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.10.2-1
- Version update
* Mon Jul 03 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.10.0-1
- Version update
* Sat May 27 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.8.18-1
- Version update
* Mon Apr 10 2006 Christian Metzen <metzench@ccux-linux.de> 2.8.17-1
- Version update
* Thu Mar 16 2006 Christian Wasem <wasem@ccux-linux.de> 2.8.16-1
- Version update
* Sat Mar 11 2006 Christian Metzen <metzench@ccux-linux.de> 2.8.14-1
- Version update
* Sat Mar 04 2006 Christian Metzen <metzench@ccux-linux.de> 2.8.13-1
- Version update
* Mon Feb 13 2006 Christian Wasem <wasem@ccux-linux.de> 2.8.12-1
- Version update
* Sat Jan 28 2006 Christian Metzen <metzench@ccux-linux.de> 2.8.11-1
- Version update
* Sun Jan 22 2006 Christian Metzen <metzench@ccux-linux.de> 2.8.10-1
- Version update
* Sat Dec 10 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.9-1
- Version update
* Wed Nov 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.8-1
- Version update
* Wed Nov 16 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.7-1
- Version update
* Tue Oct 04 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.6-1
- Version update
* Tue Oct 04 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.5-1
- Version update
* Wed Sep 28 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.4-1
- Version update
* Mon Sep 26 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.3-2
- Refined files list, added config option
* Sun Sep 25 2005 Christian Metzen <metzench@ccux-linux.de> 2.8.3-1
- Version update
* Thu Jun 16 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.8-1
- Update to Version 2.6.8
* Wed Apr 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.7-1
- Update to Version 2.6.7
* Mon Apr 11 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.6-1
- Update to Version 2.6.6
* Sun Apr 10 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.5-1
- Update to Version 2.6.5
* Wed Mar 02 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.4-1
- Update to Version 2.6.4
* Tue Mar 01 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.3-1
- Update to Version 2.6.3
* Sat Feb 05 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.2-1
- Update to Version 2.6.2
* Wed Jan 19 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.1-2
- Added Obsoletes Tag
* Mon Jan 10 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.1-1
- Version Update to 2.6.1
* Sat Sep 04 2004 Christian Metzen <metzench@ccux-linux.de> 2.4.9-1
- Update to Version 2.4.9
